/*---------------------------------------------------
/* Gap
/*  Written by Azuron 1991 4.14(Sun.)
/* Oh!X 1991-11
/* 最後まで行ったことがないので完全に正常動作するか不明
// V3.20以降専用
/*---------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_CHECK='C'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
//width(0)
//tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す
lineWidth(1.0)

vpriority(TPAGE,GPAGE0,GPAGE2,GPAGE1,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE2):// GPAGE1は仮想画面なので表示しない

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,j,r,try,maxtry=4
int cml=1:/* コンパイルする場合はcml=1にする;X-BASIC'はコンパイル相当
dim int cd(52),ba(52),Ace(4),dt(72)://,grd(2362*2)

/*---------------------------------------------------

// 音声データ読み込み
int snd_pasa=a_setPlayData("gap1.mp3")
int snd_boo =a_setPlayData("gap2.mp3")

prep()
datmake()
/* メイン
repeat
	vinit()
	try_disp()
	shuffle(52)
	layout()
	Acut()
	repeat
		r=play()
	until r>1
	if r=3 then r=ending()
	again()
until r=4
/* 終了

// 音声バッファー開放
a_end(snd_pasa)
a_end(snd_boo)

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

/*---------------------------------------------------

func int play()
/* 遊戯
//int bl,br
int n,mx,my
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	repeat
	until getTouchStatus()<>TOUCH_NONE
	
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)
	
//	repeat
//		msstat(n,n,bl,br)
//		mspos(mx,my)
//	until bl
	
	// メニューは色で判定している
	apage(GPAGE1)
	n=bitmapPoint(mx,my)
	apage(GPAGE0)
//	locate(0,30):print "n=";n
	switch n
		case 2
			n=move(mx,my)
			break
		case 3
			n=retry(356,localizedString("やり直しますか？","Retry?"))+1
			break
		case 4
			n=dead_end()
			break
		case 5
			if endchk(9) then n=0 else n=3
			break
		case 6
			if quit()    then n=4 else n=0
			break
		case 0
		default
			break
	endswitch
	return(n)
endfunc

/*---------------------------------------------------

func int move(x;int,y;int)
/* カード移動
//int n,bl
int br=0
int mx,my,p1,p2,edge
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	p1=((y-100)\102)*13+((x-48)\52)
	if ba(p1)=0 then return(1)
	square(9,p1)

	repeat
	until getTouchStatus()<>TOUCH_NONE
	
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)

//	repeat
//		msstat(n,n,bl,br)
//		mspos(mx,my)
//	until bl or br

	edge=0
//	if br then {
//		square(0,p1)
//		return(0)
//	}
	p2=((my-100)\102)*13+((mx-48)\52)
	if check(p1,p2) then {
//		locate(0,33):print "移動できないによる元場所消去:p1=";p1
		square(0,p1)
		return(1):// 選択継続の印
	}
//	locate(0,33):print "選択による元場所消去:p1=";p1
	erase(p1)
	cardPut(xyz(0,p2),xyz(1,p2),ba(p1),NO)
	SE(snd_pasa)
	ba(p2)=ba(p1)
	ba(p1)=0
	return(0)
endfunc

/*---------------------------------------------------

func int check(p1;int,p2;int)
/* 移動できるかチェック
// リターン値：1=移動不可 , 0=移動可能
int c,edge=0,d
	c=ba(p1)
	if ba(p2)<>0 then return(1)
	if p2 mod 13=0 then edge=1
	if edge=1 and same(c)<>2 then return(1)
	if edge=1 and same(c)=2  then return(0)
	if p2<>0 then d=ba(p2-1)
	if ba(p2-1)=0 then return(1)
	if suit(c)<>suit(d) or same(c)-same(d)<>1 then return(1)
	return(0)
endfunc

/*---------------------------------------------------

func layout()
/* レイアウト
int i,j,p,t=0,r=0
	for j=0 to 3
		for i = 0 to 12
			p=j*13+i
			if ba(p)<>0 then continue
			if same(cd(r))=1 then Ace(t)=p:t=t+1
			cardPut(xyz(0,p),xyz(1,p),cd(r),NO)
			ba(p)=cd(r)
			r=r+1
		next
	next
endfunc

/*---------------------------------------------------

func Acut()
/* Aを抜く
int x,y,p
dim int xx(4),yy(4)
	for i=0 to 3
		p=Ace(i)
		ba(p)=0
		xx(i)=xyz(0,p):yy(i)=xyz(1,p)
	next
	for i=0 to 71
		for j=0 to 3
			x=(dt(i) mod 6)*8+xx(j)
			y=(dt(i)\6)*8+yy(j)
			fill16X68(x,y,x+7,y+7,0)
			if cml then for x=0 to 5500:next://wait(0.0005)
		next
	next
endfunc

/*---------------------------------------------------

func int dead_end()
/* 行き詰まった場合の処理
int i,j,k,p,z=0,f=0,ct=0
dim int A(4)={1,14,27,40}
	if endchk(1)=0 then return(3)
	if try>=maxtry then return(retry(352,localizedString("もう一度しますか？","Retry?"))+4)

	for j=0 to 3
		p=j*13
		if same(ba(p))<>2 then {
			for k=0 to 12
				if ba(p)=0 then ba(p)=A(ct):ct=ct+1
				cd(z)=ba(p)
				ba(p)=0:erase(p)
				z=z+1:p=p+1
			next
			continue
		}
		for i=1 to 12
			p=j*13+i:f=0
			if suit(ba(p-1))<>suit(ba(p)) then f=1
			if same(ba(p))-same(ba(p-1))<>1 then f=1
			if f=1 then {
				p=j*13+i
				for k=i to 12
					if ba(p)=0 then ba(p)=A(ct):ct=ct+1
					cd(z)=ba(p)
					ba(p)=0:erase(p)
					z=z+1:p=p+1
				next
				break
			}
		next
	next

	try=try+1
	try_disp()
	shuffle(z)
	layout()
	Acut()
	return(0)
endfunc

/*---------------------------------------------------

func endchk(sw;int)
/* 本当にクリア
int i,j,p,f=0
	for j=0 to 3
		for i=0 to 10
			p=j*13+i
			if ba(p)-ba(p+1)<>-1 then f=1:break
			if suit(ba(p))<>suit(ba(p+1)) then f=1:break
		next
	next
	if sw=0 and f=1 then SE(snd_boo)
	return(f)
endfunc

/*---------------------------------------------------

func try_disp()
/* 何回目のトライか表示
	  fill16X68(324,60,445,87,0)
	symbol16X68(324,60,   " TRY",2,15,FONT,FNTSZ)
	symbol16X68(422,60,str$(try),2,15,FONT,FNTSZ)
endfunc

/*---------------------------------------------------

func xyz(sw;int,p;int)
/* 場に出すXY座標を求める
int r
	if sw=0 then r=(p-(p\13)*13)*52+48
	if sw=1 then r=(p\13)*102+100
	return(r)
endfunc

/*---------------------------------------------------

func flbx(x0;int,y0;int,x1;int,y1;int,c0;int,c1;int)
/* フィル＆ボックス
	fill16X68(x0,y0,x1,y1,c0)
	box16X68( x0,y0,x1,y1,c1)
endfunc

/*---------------------------------------------------

func vinit()
/* 変数初期化
	for i=0 to 51
		cd(i)=i+1
		ba(i)=0
	next
	try=1
endfunc

/*---------------------------------------------------

func square(col;int,p;int)
/* ボックス表示
int x,y
	x=xyz(0,p)
	y=xyz(1,p)
	box16X68( x-2,y-2,x+CARD_WX+1,y+CARD_WY+1,col)
endfunc

/*---------------------------------------------------

func erase(p;int)
/* 場のカードを消す
int x,y
	x=xyz(0,p)
	y=xyz(1,p)
	fill16X68(x-2,y-2,x+CARD_WX+1,y+CARD_WY+1,0)
endfunc

/*---------------------------------------------------

func shuffle(max;int)
/* シャッフル
int i,a,b,c
	apage(GPAGE2)
	flbx(264,282,538,330,2,5)
	symbol16X68(286,290,"ＳＨＵＦＦＬＥ",2,15,FONT,FNTSZ)
	for i=0 to 199
		a=int(rnd()*max):b=int(rnd()*max)
		c=cd(a):cd(a)=cd(b):cd(b)=c
	next
	if cml then cwait(20)
	wipe()
	apage(GPAGE0)
endfunc

/*---------------------------------------------------

func int same(c;int)
/* 数を調べる
	return((c-1) mod MAX_TRUMP+1)
endfunc

/*---------------------------------------------------

func int suit(c;int)
/* スートを調べる
	return((c-1) \ MAX_TRUMP)
endfunc

/*---------------------------------------------------

func cwait(tm;int)
/* ウエイト
int i
	for i=0 to tm
		wait(0.05)
	next
endfunc

/*---------------------------------------------------

func wait2()
/* ウエイト2
// X68 10MHz for i=0 to n*500:n=500回ループで42秒
	wait((42.0/500.0)*2)
//int i
//	for i=0 to 999:next
endfunc

/*---------------------------------------------------

func datmake()
/* データ作成(for Acut)
int i,a,b,k
	for i =0 to 71:dt(i)=i:next
	for i =0 to 49
		a=int(rnd()*72):b=int(rnd()*72)
		k=dt(a):dt(a)=dt(b):dt(b)=k
	next
endfunc

/*---------------------------------------------------

func retry(x;int,m;str)
/* リトライ？
	j=YesNo(x,m)
	return(j)
endfunc

/*---------------------------------------------------

func quit()
/* やめますか？
	j=YesNo(356,localizedString("やめますか？","Quit?"))
	return(j)
endfunc

/*---------------------------------------------------

func int YesNo(xx;int,m;str)
/* Yes or No
//int n,bl,br,mx,my
int f
	
	dim str menues(1)
	if isLocalizeJapan() then {
		menues={"はい","いいえ"}
	} else {
		menues={"Yes","No"}
	}
	switch selectMenu(m,menues)
		case 0
			f=1
			break
		case 1
			f=0
			break
	endswitch
	return(f)
endfunc

/*---------------------------------------------------

func int ending()
/* エンディング
int f
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="おめでとうございます\nもう一度しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Congratulations!!\nTry again?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			f=1
			break
		case 1
			f=0
			break
	endswitch
	return(f)
endfunc

/*---------------------------------------------------

func SE(t;int)
/* 効果音
	a_play(t)
	repeat:until a_stat(t)=0
endfunc

/*---------------------------------------------------

func again()
/* もう一度トライする場合の準備
	fill16X68( 48,100,719,501,0)
	fill16X68(326, 60,457, 90,0)
endfunc

/*---------------------------------------------------

func prep()
/* 準備
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	setgPalet16X68(1,&h000000ff):// palet(1,0)
	setgPalet16X68(8,&h006000ff):// palet(8,rgb(0,6,0))

	box16X68(34,94,731,505,14)
	symbol16X68(350,16,"GAP",3,13,FONT,FNTSZ)
	// GPAGE1は仮想画面であり、位置判定用の色を塗ってある
	apage(GPAGE0):			flbx( 60,56,161,89,2,14):symbol16X68( 84,60,"Retry"  ,1.5,11,FONT,FNTSZ)
	apage(GPAGE1):gColor(3):fill( 60,56,161,89)
	//
	apage(GPAGE0):			flbx(180,56,281,89,2,14):symbol16X68(184,60,"Dead End",1.5,11,FONT,FNTSZ)
	apage(GPAGE1):gColor(4):fill(180,56,281,89)
	//
	apage(GPAGE0):			flbx(488,56,587,89,2,14):symbol16X68(490,60,"Complete",1.5,11,FONT,FNTSZ)
	apage(GPAGE1):gColor(5):fill(488,56,587,89)
	//
	apage(GPAGE0):			flbx(606,56,707,89,2,14):symbol16X68(634,60,"Quit"	  ,1.5,11,FONT,FNTSZ)
	apage(GPAGE1):gColor(6):fill(606,56,707,89)
	//
	apage(GPAGE1):gColor(2):fill( 48,100,719,501)
	apage(GPAGE0)
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
